using System;
using System.Drawing;
using System.Drawing.Drawing2D;


namespace DrawObjects
{

  
	
	public class DrawPolygon 
	{
			Color SurfaceColor= Color.Coral;
		
		Size size;
		public int	Order=5;			
		
		protected int m_GradientSize;

		public DrawPolygon()
		{
		
			size= new Size(30,30);
		}


		/// <summary>
		/// Metjod that draw the regular polygon.
		/// </summary>
		/// <param name="pDC">The reference to the current device context</param>
		public 	void Draw(Graphics pDC)
		{
            {
                double r = size.Width / 2;              // Radius

                Point[] Vertex = new Point[Order];

                Point[] vert = new Point[Order + 1];

                Color color = Color.BlueViolet;

                Point pos = new Point(50,50);
                Color[] surroundColor = new Color[Order];
                float[] blendPosition = new float[Order];
			
				double Rotation=0;
                for (int i = 0; i < Order; i++)
                {
                    double angle = 2.0 * Math.PI * (double)i / (double)Order;
                    Vertex[i].X = (int)Math.Round(r * Math.Cos(angle + Rotation) + (double)pos.X);
                    Vertex[i].Y = (int)Math.Round(r * Math.Sin(angle + Rotation) + (double)pos.Y);

                  
                    vert[i] = Vertex[i];
                    surroundColor[i] = Color.CadetBlue;
                }

                //**** vertex to the center of the polygon
                vert[Order] = vert[0];

                using (PathGradientBrush pathGradient = new PathGradientBrush(Vertex))
                {
				
                    pathGradient.CenterColor = Color.FromArgb(SurfaceColor.R / 2, SurfaceColor.G / 2, SurfaceColor.B / 2);
                    pathGradient.SurroundColors = surroundColor;

                    DrawTriangle(pDC, pathGradient,Vertex);

                    DrawShape(pDC, vert);
                }
                

                
            }
		}

	
		public void DrawShape(Graphics pDC, Point[] vert)
		{
			Color ShapeColor=Color.Black;
            using (Pen p = new Pen(Color.FromArgb(ShapeColor.R / 2, ShapeColor.G / 2, ShapeColor.B / 2), 2.0f))
            {
                    //**** Draw the shape of the polygon
                    pDC.DrawPolygon(p, vert);
                    //**** end Draw the shape of the polygon
           
            }
		}
		
	    public void DrawTriangle(Graphics pDC, Brush brush, Point[] vert)
		{
		    
                    pDC.FillPolygon(brush, vert);
               
			
		}

	
		
		
		
		
		

		/// <summary>
		/// Calcola la dimensione del Polygon e dell'eventuale box relativo alla DrawExtendedInformation
		/// </summary>
		/// <returns></returns>
		public Size GetDrawSize(Graphics p_pDC)
		{
			//Size del Polygon
			Size s=size;

            /*
            DrawLabel dl = new DrawLabel(this, ComposeLabelMessage());
            SizeF sf= dl.Measure(p_pDC);
            Size ls = new Size((int)sf.Width, (int)sf.Height);
            */

			/*
			if(ShowInformation) 
			{	
				Size ExtendedInformationSize = ExtendedInformation.GetDrawSize(p_pDC);
				Size ExtendedInfoSize = ExtendedInformation.GetDrawSize(p_pDC);
				if (s.Width < ExtendedInformationSize.Width)
					s.Width = ExtendedInformationSize.Width;
			
				s.Height = s.Height + ExtendedInfoSize.Height + 5;
				s.Height = s.Height + ExtendedInfoSize.Height +  5;
			}
			*/
            //s.Height += ls.Height;
			return s;
		}
	}
}
